unit WebMod51;
interface
uses
  Windows, Messages, SysUtils, Classes, HTTPApp, CompProd, PagItems,
  MidProd, XMLBrokr, Db, DBClient, MConnect, MidItems, ImgButtons,
  QueryComps, ShowXML, ReconcileProd;

type
  TWebModule2 = class(TWebModule)
    DCOMConnection1: TDCOMConnection;
    XMLBroker1: TXMLBroker;
    CustomerOrdersMidasPageProducer: TMidasPageProducer;
    QueryForm1: TQueryForm;
    QueryButtons1: TQueryButtons;
    DataForm1: TDataForm;
    DataGrid1: TDataGrid;
    ImgDataNavigator1: TImgDataNavigator;
    FieldGroup1: TFieldGroup;
    ImgDataNavigator2: TImgDataNavigator;
    NextXMLPacketButton: TSubmitQueryButton;
    QueryFieldGroup1: TQueryFieldGroup;
    HiddenRecNo: TQueryHiddenText;
    ReconcilePageProducer1: TReconcilePageProducer;
    CustNo: TFieldText;
    Company: TFieldText;
    Addr1: TFieldText;
    City: TFieldText;
    State: TFieldText;
    Zip: TFieldText;
    Country: TFieldText;
    Contact: TFieldText;
    FieldStatus1: TFieldStatus;
    OrderNo: TTextColumn;
    CustNo2: TTextColumn;
    SaleDate: TTextColumn;
    ShipDate: TTextColumn;
    ShipVIA: TTextColumn;
    ItemsTotal: TTextColumn;
    AmountPaid: TTextColumn;
    StatusColumn1: TStatusColumn;
    procedure WebModule2WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure XMLBroker1RequestRecords(Sender: TObject;
      Request: TWebRequest; out RecCount: Integer;
      var OwnerData: OleVariant; var Records: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule2: TWebModule2;

implementation
{$R *.DFM}
uses
  MainUnit;

procedure TWebModule2.WebModule2WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
const
  Str = 'Next set of %d records (currently showing %d-%d)';
var
  RecNo: String;
  RecNr: Integer;
begin
  RecNo := Request.QueryFields.Values['HiddenRecNo'];
  if RecNo <> '' then
  try
    RecNr := StrToInt(RecNo)
  except
    RecNr := 0
  end;
  NextXMLPacketButton.Caption :=
    Format(Str,[XMLBroker1.MaxRecords,
                RecNr+1,RecNr+XMLBroker1.MaxRecords]);
  HiddenRecNo.Text := IntToStr(RecNr+XMLBroker1.MaxRecords);
  Log('HiddenRecNo #1: '+HiddenRecNo.Text);
  if DComConnection1.Connected then Log('DCOMConnection = True')
                               else Log('DCOMConnection = False');
  { next statement may cause XMLBroker to Request Records }
//DComConnection1.Connected := True;
  Response.Content := CustomerOrdersMidasPageProducer.Content;
//DComConnection1.Connected := False
end;

procedure TWebModule2.XMLBroker1RequestRecords(Sender: TObject;
  Request: TWebRequest; out RecCount: Integer; var OwnerData: OleVariant;
  var Records: String);
begin
  OwnerData := IntToStr(StrToInt(HiddenRecNo.Text) - XMLBroker1.MaxRecords);
  Log('HiddenRecNo #2: '+HiddenRecNo.Text);
  Log('Out RecCount: '+IntToStr(RecCount));
  if DComConnection1.Connected then Log('DCOMConnection = True')
                               else Log('DCOMConnection = False');
end;

end.

